
function addLoadEvent(func){
	var oldonload = window.onload;
	if (typeof window.onload != 'function'){
		window.onload = func;
	}else{
		window.onload = function(){
			oldonload();
			func();
		}
	}
}


//addLoadEvent(user_ttt_init_sina_cn);
//addLoadEvent(friend_read_init);

//为元素绑定事件
function addListener(element, e, fn) {
    if (element.addEventListener) {
        element.addEventListener(e, fn, false);
    } else {
        element.attachEvent("on" + e, fn);
    }
}



each(document.querySelectorAll('[data-role="slide"]'),function(){
   
	imgSlide(this);
});

//图片轮播
function imgSlide(slideWrapper){
	var slideTimer;
	var slideWrapper = slideWrapper;
	if(!slideWrapper)return;
 
	var nav = navigator;
	var vendor = (/webkit/i).test(nav.appVersion) ? "webkit" : (/firefox/i).test(nav.userAgent) ? "Moz" : "opera" in window ? "O" : (/MSIE/i).test(nav.userAgent) ? "ms" : "";
	var TEnd = vendor === "webkit"?'webkitTransitionEnd':vendor === "Moz"?TEnd = "transitionend":vendor === "O"?TEnd = "oTransitionEnd":vendor === "ms"?TEnd = "MSTransitionEnd":'';

	var itemWidth = slideWrapper.querySelector('.img_box').offsetWidth;
	var listNum = slideWrapper.querySelectorAll('.img_box').length;
	var startX,endX,startY,endY,moveX,lockDirection;
	var currentIndex = 0;
	
	

	//设置滚动list的宽度
	if(slideWrapper.querySelector('.slide_img_list')){
		slideWrapper.querySelector('.slide_img_list').style.width =  itemWidth*(listNum+2)+ 'px';
	}



	slideWrapper.addEventListener('touchstart',function(e){
		clearInterval(slideTimer);
		startX = endX = e.touches[0].pageX;
		startY = endY = e.touches[0].pageY;
		lockDirection = '';
	},false);

	slideWrapper.addEventListener('touchmove',function(e){

		//方向锁定 不获取另一方向的坐标
		if(!lockDirection || lockDirection === 'x')endX = e.changedTouches[0].pageX;
		if(!lockDirection || lockDirection === 'y')endY = e.changedTouches[0].pageY;

		//判断锁定方向
		if(!lockDirection){
			Math.abs(endX-startX)<= Math.abs(endY-startY)?lockDirection = 'y':lockDirection = 'x';
		}

		if(lockDirection === 'x'){
			e.preventDefault();
			this.style[vendor+'Transition'] = '0';
			this.style[vendor+'Transform'] = 'translate3d(-'+(currentIndex*itemWidth+startX-endX)+'px,0,0)';
			if(index(document.querySelector('#indicator .active')) === 3){
				if(startX-endX < 100){
					this.style[vendor+'Transform'] = 'translate3d(-'+(currentIndex*itemWidth+startX-endX)+'px,0,0)';
				}else{
					//this.style[vendor+'Transform'] = 'translate3d(-'+(currentIndex*itemWidth+100)+'px,0,0)';
				}
			}
			if(index(document.querySelector('#indicator .active')) === 1){
				if(Math.abs(endX-startX)< 100){
					this.style[vendor+'Transform'] = 'translate3d('+(endX-startX)+'px,0,0)';
				}else{
					//this.style[vendor+'Transform'] = 'translate3d('+100*(endX-startX)/Math.abs(endX-startX)+'px,0,0)';
				}
			}
		}
	},false);
	slideWrapper.addEventListener('touchend',function(e){
		if(lockDirection === 'x'){
			e.preventDefault();
			moveX = endX - startX;
			if(moveX < 0){
				if(currentIndex+1 < listNum){
					currentIndex += 1;
				}
			}else{
				if(currentIndex > 0){
					currentIndex -= 1;
				}
			}
			moveSlide(currentIndex);
		}
	},false);
	function moveSlide(index){
		if(vendor === 'ms'){
			slideWrapper.style.cssText += 'position:relative;left:0;'
			slideWrapper.style.left = '-'+(index)*itemWidth+'px';
		}else{
			slideWrapper.style[vendor+'Transform'] = 'translate3d(-'+(index)*itemWidth+'px,0,0)';
			slideWrapper.style[vendor+'Transition'] = '.5s';
		}
		each(document.querySelectorAll('#indicator li'),function(i){
			removeClass(this,'active');
			i === index ? this.className = 'active':'';
		});

		//图片延迟显示…
		var imgWrapper = slideWrapper.querySelectorAll('.img_box')[index];
		if(imgWrapper && !imgWrapper.getAttribute('data-unload')){
			console.log(1);
			imgWrapper.setAttribute('data-unload',0);
			each(imgWrapper.querySelectorAll('img'),function(){
				this.src = this.getAttribute('data-src');
			});
		}
	}
};





/******************** BASE **************************/

//阻止默认事件  firefox inline script e必须写成event
function preventDef(e){
	var event = e ||window.event;
	return event.preventDefault?event.preventDefault():event.returnValue = false;
}

// 数组循环操作
function each(Aobj,fn){


	if(!Aobj||!Aobj.length||typeof fn !== 'function'){
	return ;
	}
	for(var i=0,j=Aobj.length;i<j;i++){
		fn.call(Aobj[i],i);
	}
}

//添加class
function addClass(ele,cls) {
	if (!this.hasClass(ele,cls)) ele.className += " "+cls;
}
//删除class
function removeClass(ele,cls) {
	if (hasClass(ele,cls)) {
	var reg = new RegExp('(\\s|^)'+cls+'(\\s|$)');
		ele.className=ele.className.replace(reg,' ');
	}
}
//是否有class
function hasClass(ele,cls) {
	return ele.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
}

//元素位置 
function index(elem){
	var k=0, e=elem;
	while(e){
		if ("previousSibling" in e ){
			e = e.previousSibling;
			if(e && e.nodeType !== 1)continue;
			k = k + 1;
		}else{
			k= -1;
			break;
		}
	}
	return k;
}

//获得当前样式 di/element
function getStyle(el,styleProp){
	var x;
	if(typeof x === 'string') x = document.getElementById(el);
	if('tagName' in el) x = el;
	if (x.currentStyle)
		var y = x.currentStyle[styleProp];
	else if (window.getComputedStyle)
		var y = document.defaultView.getComputedStyle(x,null).getPropertyValue(styleProp);
	return y;
}

//模拟点击事件
function triggerClick(el) {
	if(el.click) {
		el.click();
	}else{
		try{
			var evt = document.createEvent('Event');
			evt.initEvent('click',true,true);
			el.dispatchEvent(evt);
		}catch(e){alert(e)};        
	}
}

//元素绝对位置 table iframe 不适用
function getEleLeft(element){
	var actualLeft = element.offsetLeft;
	var current = element.offsetParent;
	while (current !== null){
		actualLeft += current.offsetLeft;
		current = current.offsetParent;
	}
	return actualLeft;
}
function getEleTop(element){
	var actualTop = element.offsetTop;
	var current = element.offsetParent;
	while (current !== null){
		actualTop += current.offsetTop;
		current = current.offsetParent;
	}
	return actualTop;
}

//追加 pageshow 事件
function addOnPageShow(fn){
	if(typeof window.onpageshow == 'function'){
		var tempOnPageShow = window.onpageshow;
		window.onpageshow = function(){
			tempOnPageShow();
			fn();
		}
	}else{
		window.onpageshow = function(){
			fn();
		}
	}
}

//追加 onscroll 事件
function addOnscroll(fn){
	if(typeof window.onscroll == 'function'){
		var tempFn = window.onscroll;
		window.onscroll = function(){
			tempFn();
			fn();
		}
	}else{
		window.onscroll = function(){
			fn();
		}
	}
}